#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
//varying vec2 v_alphaCoord;

uniform vec2 resolution;
uniform float blurRadius;
uniform float sampleNum;

vec4 blur(vec2);

void main(void)
{
    vec4 col = blur(v_texCoord); //* v_fragmentColor.rgb;
    col.rgb = col.rgb * col.a;
    gl_FragColor = vec4(col) * v_fragmentColor;
}

vec4 blur(vec2 p)
{
    vec4 v4Colour = vec4(0,0,0,0);
    if (blurRadius > 0.0 && sampleNum > 1.0)
    {
        vec4 col = vec4(0,0,0,0);
        vec2 unit = vec2(0,0);
        unit.x = 1.0 / resolution.x;
        unit.y = 1.0 / resolution.y;
        
        float r = blurRadius;
        float sampleStep = r / sampleNum;
        
        float count = 0.0;
        
        for(float x = -r; x < r; x += sampleStep)
        {
            for(float y = -r; y < r; y += sampleStep)
            {
                float weight = (r - abs(x)) * (r - abs(y));
                v4Colour = texture2D(CC_Texture0, p + vec2(x * unit.x, y * unit.y));
                p.y += 0.5;
                v4Colour.a = texture2D(CC_Texture0, p + vec2(x * unit.x, y * unit.y)).r;
                p.y -= 0.5;
                col += v4Colour * weight;
                count += weight;
            }
        }
        
        return col / count;
    }
	
    v4Colour = texture2D(CC_Texture0, p);
    p.y += 0.5;
    v4Colour.a = texture2D(CC_Texture0, p).r;
    p.y -= 0.5;
    return v4Colour;
}